diff --git a/gtk2_ardour/ardour_image_compositor_socket.h b/gtk2_ardour/ardour_image_compositor_socket.h
index 6ed92ef..03f0086 100644
--- a/gtk2_ardour/ardour_image_compositor_socket.h
+++ b/gtk2_ardour/ardour_image_compositor_socket.h
@@ -46,6 +46,8 @@ namespace ardourvis
 	/** the number of characters used to for the size of the image data message */
 	const int32_t IMAGE_DATA_MESSAGE_SIZE_CHARS = 32 ;
 
+	/** the number of characters in a return/reply message */
+	const int32_t RETURN_MSG_SIZE = 3 ;
 	// ------------------------------------------------------------------------- //
 	// Main Actions
 	// we join the action chars with items to create the message
diff --git a/gtk2_ardour/editor_imageframe.cc b/gtk2_ardour/editor_imageframe.cc
index d2defd4..0dcbf46 100644
--- a/gtk2_ardour/editor_imageframe.cc
+++ b/gtk2_ardour/editor_imageframe.cc
@@ -1081,19 +1081,34 @@ Editor::markerview_end_handle_end_trim (ArdourCanvas::Item* item, GdkEvent* even
 void
 Editor::handle_new_imageframe_time_axis_view(const string & track_name, void* src)
 {
+	ignore_route_list_reorder = true;
+	ignore_route_order_sync = true;
+	no_route_list_redisplay = true;
+
 	ImageFrameTimeAxis* iftav ;
 	iftav = new ImageFrameTimeAxis(track_name, *this, *session, *track_canvas) ;
 	iftav->set_time_axis_name(track_name, this) ;
 	track_views.push_back(iftav) ;
 
-	TreeModel::Row row = *(route_display_model->append());
 
+	TreeModel::Row row = *(route_display_model->append());
+#if 1 // fake Route workaround
+	row[route_display_columns.route] = 
+		session->new_video_track(iftav->name());
+#endif
 	row[route_display_columns.text] = iftav->name();
 	row[route_display_columns.tv] = iftav;
+	row[route_display_columns.visible] = true;
 	route_list_display.get_selection()->select (row);
 
 	iftav->GoingAway.connect(bind(mem_fun(*this, &Editor::remove_route), (TimeAxisView*)iftav)) ;
+	iftav->set_old_order_key (route_display_model->children().size() - 1);
 	iftav->gui_changed.connect(mem_fun(*this, &Editor::handle_gui_changes)) ;
+
+	ignore_route_list_reorder = false;
+	ignore_route_order_sync = false;
+	no_route_list_redisplay = false;
+	redisplay_route_list ();
 }
 
 void
diff --git a/gtk2_ardour/imageframe.cc b/gtk2_ardour/imageframe.cc
index 7ff05ee..8758819 100644
--- a/gtk2_ardour/imageframe.cc
+++ b/gtk2_ardour/imageframe.cc
@@ -35,7 +35,7 @@ ImageFrame::ImageFrame(Group& parentx, ArtPixBuf* pbuf, double x, double y, Gtk:
 : Item(GNOME_CANVAS_ITEM(g_object_new(get_type(),0)))
 {
   item_construct(parentx);
-  set("pixbuf", pbuf, "x", x,"y", y,"width", w,"height", h, 0);
+  set("pixbuf", pbuf, "x", x,"y", y,"width", w,"height", h, "anchor", anchor, 0);
 }
 
 ImageFrame::ImageFrame(Group& parentx)
diff --git a/gtk2_ardour/imageframe_socket_handler.cc b/gtk2_ardour/imageframe_socket_handler.cc
index aa32292..c27c6f9 100644
--- a/gtk2_ardour/imageframe_socket_handler.cc
+++ b/gtk2_ardour/imageframe_socket_handler.cc
@@ -2313,17 +2313,21 @@ ImageFrameSocketHandler::read_message(std::string& msg)
 /**
  * Reads a reply message ("RT0"/"RT1") from the Socket
  *
- * @return the return value from the socket call
+ * @return true if "RT0" was received,, otherwise false
  */
-int
+bool
 ImageFrameSocketHandler::read_result()
 {
-	char buf[4] ;
-	int retcode = ::recv(theArdourToCompositorSocket, buf, 3, 0) ;
-	buf[3]='\0';
-	std::cout << "Received Result [" << buf << "]\n" ;
-	// TODO ; check if "RT1" or "RT0" or whatever..
-	return(retcode) ;
+	char buf[(ardourvis::RETURN_MSG_SIZE)+1] ;
+	int retcode = ::recv(theArdourToCompositorSocket, buf, ardourvis::RETURN_MSG_SIZE, 0) ;
+	buf[ardourvis::RETURN_MSG_SIZE]='\0';
+	if (retcode > 0) {
+	  std::cout << "Received Result [" << buf << "]\n" ;
+	  if (retcode == ardourvis::RETURN_MSG_SIZE && buf == ardourvis::RETURN_TRUE) {
+	    return (true);
+	  }
+	}
+	return(false) ;
 }
 
 /**
diff --git a/gtk2_ardour/imageframe_socket_handler.h b/gtk2_ardour/imageframe_socket_handler.h
index 1a6b09c..0835f18 100644
--- a/gtk2_ardour/imageframe_socket_handler.h
+++ b/gtk2_ardour/imageframe_socket_handler.h
@@ -671,11 +671,11 @@ class ImageFrameSocketHandler : public sigc::trackable
 		int read_message(std::string& msg) ;
 
 		/**
-		 * Reads a reply message ("RT0"/"RT1") from the Socket
+		 * Reads a return message ("RT0"/"RT1") from the Socket
 		 *
-		 * @return the return value from the socket call
+		 * @return true if "RT0" was received,, otherwise false
 		 */
-		int read_result();
+		bool read_result();
 		
 		/**
 		 * Convenience method to compose and send a success messasge back to the Image Compositor
diff --git a/gtk2_ardour/imageframe_time_axis.cc b/gtk2_ardour/imageframe_time_axis.cc
index f3630e7..700a160 100644
--- a/gtk2_ardour/imageframe_time_axis.cc
+++ b/gtk2_ardour/imageframe_time_axis.cc
@@ -138,6 +138,7 @@ ImageFrameTimeAxis::~ImageFrameTimeAxis ()
 void
 ImageFrameTimeAxis::set_height (uint32_t h)
 {
+	bool changed = (height == 0) || (h != height);
 	VisualTimeAxis::set_height(h) ;
 	
 	// tell out view helper of the change too
@@ -146,8 +147,10 @@ ImageFrameTimeAxis::set_height (uint32_t h)
 		view->set_height((double) height) ;
 	}
 	
+	if (changed) {
 	// tell those interested that we have had our height changed
-	 gui_changed("track_height",(void*)0); /* EMIT_SIGNAL */
+		gui_changed("track_height",(void*)0); /* EMIT_SIGNAL */
+	}
 }
 
 /**
diff --git a/gtk2_ardour/imageframe_view.cc b/gtk2_ardour/imageframe_view.cc
index f353813..d129147 100644
--- a/gtk2_ardour/imageframe_view.cc
+++ b/gtk2_ardour/imageframe_view.cc
@@ -67,7 +67,7 @@ ImageFrameView::ImageFrameView(const string & item_id,
 	uint32_t width,
 	uint32_t height,
 	uint32_t num_channels)
-  : TimeAxisViewItem(item_id, *parent, *tv, spu, basic_color, start, duration,
+  : TimeAxisViewItem(item_id, *parent, *tv, spu, basic_color, start, duration, false,
 		     TimeAxisViewItem::Visibility (TimeAxisViewItem::ShowNameText|
 						   TimeAxisViewItem::ShowNameHighlight|
 						   TimeAxisViewItem::ShowFrame|
@@ -86,7 +86,16 @@ ImageFrameView::ImageFrameView(const string & item_id,
 	memcpy(the_rgb_data, rgb_data, (width*height*num_channels)) ;
 
 	ArtPixBuf* pbuf ;
-	pbuf = art_pixbuf_new_rgba(the_rgb_data, width, height, (num_channels * width));
+	if (num_channels==3)
+	  pbuf = art_pixbuf_new_rgb(the_rgb_data, width, height, (num_channels * width));
+	else if (num_channels==4)
+	  pbuf = art_pixbuf_new_rgba(the_rgb_data, width, height, (num_channels * width));
+	else  {
+	  ; // error unsupported image data format
+	  art_free(the_rgb_data);
+	  std::cerr << "imageframe_view: unsupported image data format" << std::endl;
+	  return;
+	}
 	imageframe = 0 ;
 	
 	//calculate our image width based on the track height
diff --git a/gtk2_ardour/marker_time_axis.cc b/gtk2_ardour/marker_time_axis.cc
index df041f8..f5c80be 100644
--- a/gtk2_ardour/marker_time_axis.cc
+++ b/gtk2_ardour/marker_time_axis.cc
@@ -109,6 +109,7 @@ MarkerTimeAxis::~MarkerTimeAxis()
 void
 MarkerTimeAxis::set_height (uint32_t h)
 {
+	bool changed = (height == 0) || (h != height);
 	VisualTimeAxis::set_height(h) ;
 	
 	// tell out view helper of the change too
@@ -117,8 +118,10 @@ MarkerTimeAxis::set_height (uint32_t h)
 		view->set_height((double) height) ;
 	}
 	
+	if (changed) {
 	// tell those interested that we have had our height changed
 	 gui_changed("track_height",(void*)0) ; /* EMIT_SIGNAL */
+	}
 }
 
 /**
diff --git a/gtk2_ardour/visual_time_axis.cc b/gtk2_ardour/visual_time_axis.cc
index 2035293..468b967 100644
--- a/gtk2_ardour/visual_time_axis.cc
+++ b/gtk2_ardour/visual_time_axis.cc
@@ -84,18 +84,22 @@ VisualTimeAxis::VisualTimeAxis(const string & name, PublicEditor& ed, ARDOUR::Se
 	size_button.set_name("TrackSizeButton") ;
 	visual_button.set_name("TrackVisualButton") ;
 	hide_button.set_name("TrackRemoveButton") ;
-	hide_button.add(*(Gtk::manage(new Gtk::Image(get_xpm("small_x.xpm")))));
+	hide_button.add (*(manage (new Image (::get_icon("hide")))));
+	hide_button.show_all ();
+
 	size_button.signal_button_release_event().connect (mem_fun (*this, &VisualTimeAxis::size_click)) ;
 	visual_button.signal_clicked().connect (mem_fun (*this, &VisualTimeAxis::visual_click)) ;
 	hide_button.signal_clicked().connect (mem_fun (*this, &VisualTimeAxis::hide_click)) ;
 	ARDOUR_UI::instance()->tooltips().set_tip(size_button,_("Display Height")) ;
 	ARDOUR_UI::instance()->tooltips().set_tip(visual_button, _("Visual options")) ;
 	ARDOUR_UI::instance()->tooltips().set_tip(hide_button, _("Hide this track")) ;
-		
+
+if (0) {		
+		/* old school - when we used to put an extra row of buttons in place */
 	controls_table.attach (hide_button, 0, 1, 1, 2, Gtk::FILL|Gtk::EXPAND, Gtk::FILL|Gtk::EXPAND);
 	controls_table.attach (visual_button, 1, 2, 1, 2, Gtk::FILL|Gtk::EXPAND, Gtk::FILL|Gtk::EXPAND);
 	controls_table.attach (size_button, 2, 3, 1, 2, Gtk::FILL|Gtk::EXPAND, Gtk::FILL|Gtk::EXPAND);
-
+}
 	/* remove focus from the buttons */
 	size_button.unset_flags(Gtk::CAN_FOCUS) ;
 	hide_button.unset_flags(Gtk::CAN_FOCUS) ;
@@ -154,15 +158,21 @@ VisualTimeAxis::set_height(uint32_t h)
 	if (h >= hNormal) {
 		hide_name_label ();
 		show_name_entry ();
-		other_button_hbox.show_all() ;
+		visual_button.show();
+		size_button.show();
+		hide_button.show();
 	} else if (h >= hSmaller) {
 		hide_name_label ();
 		show_name_entry ();
-		other_button_hbox.hide_all() ;
+		visual_button.hide ();
+		size_button.hide ();
+		hide_button.hide();
 	} else if (h >= hSmall) {
 		hide_name_entry ();
 		show_name_label ();
-		other_button_hbox.hide_all() ;
+		visual_button.hide ();
+		size_button.hide ();
+		hide_button.hide ();
 	}
 }
 
diff --git a/libs/ardour/ardour/session.h b/libs/ardour/ardour/session.h
index 2c9ef60..62b7f09 100644
--- a/libs/ardour/ardour/session.h
+++ b/libs/ardour/ardour/session.h
@@ -490,6 +490,8 @@ class Session : public PBD::StatefulDestructible
 	std::list<boost::shared_ptr<AudioTrack> > new_audio_track (int input_channels, int output_channels, TrackMode mode = Normal, uint32_t how_many = 1);
 	RouteList new_audio_route (int input_channels, int output_channels, uint32_t how_many);
 
+	boost::shared_ptr<Route> new_video_track (string name);
+
 	void   remove_route (boost::shared_ptr<Route>);
 
 	void   resort_routes ();
diff --git a/libs/ardour/session.cc b/libs/ardour/session.cc
index af0f31b..74e42de 100644
--- a/libs/ardour/session.cc
+++ b/libs/ardour/session.cc
@@ -2004,6 +2004,27 @@ Session::new_audio_route (int input_channels, int output_channels, uint32_t how_
 
 }
 
+boost::shared_ptr<Route>
+Session::new_video_track (string name)
+{
+	uint32_t control_id = ntracks() + nbusses() + 1;
+	shared_ptr<Route> new_route (
+		new Route ( *this, name, -1, -1, -1, -1, Route::Flag(0)
+			//ARDOUR::DataType(0)
+			));
+	new_route->set_remote_control_id (control_id);
+
+	RouteList rl;
+	rl.push_back (new_route);
+        {
+		RCUWriter<RouteList> writer (routes);
+		shared_ptr<RouteList> r = writer.get_copy ();
+                r->insert (r->end(), rl.begin(), rl.end());
+		resort_routes_using (r);
+        }
+	return new_route;
+}
+
 void
 Session::add_routes (RouteList& new_routes, bool save)
 {
